import { PayloadType } from './WorkerTaskManager';
declare type DataTransportPayloadType = PayloadType & {
    buffers?: Map<string, ArrayBufferLike>;
    progress?: number;
};
export declare class DataTransportPayload implements DataTransportPayloadType {
    name: string;
    type: string;
    cmd: string;
    id: number;
    workerId?: number | undefined;
    params?: Record<string, unknown>;
    buffers: Map<string, ArrayBufferLike>;
    progress: number;
    constructor(cmd?: string, id?: number, name?: string);
}
export declare class DataTransportPayloadUtils {
    /**
     * Package all data buffers into the transferable array. Clone if data needs to stay in current context.
     * @param {boolean} cloneBuffers
     */
    static packDataTransportPayload(payload: DataTransportPayload, cloneBuffers: boolean): {
        payload: DataTransportPayload;
        transferables: Transferable[];
    };
    static fillTransferables(buffers: IterableIterator<ArrayBufferLike>, output: Transferable[], cloneBuffers: boolean): void;
    static unpackDataTransportPayload(payload: DataTransportPayload, cloneBuffers: boolean): void;
}
/**
 * Object manipulation utilities.
 */
export declare class ObjectManipulator {
    /**
     * Applies values from parameter object via set functions or via direct assignment.
     *
     * @param {Record<string, unknown>} objToAlter The objToAlter instance
     * @param {Record<string, unknown>} params The parameter object
     * @param {boolean} forceCreation Force the creation of a property
     */
    static applyProperties(objToAlter: Record<string, unknown>, params: Record<string, unknown>, forceCreation: boolean): void;
}
export {};
//# sourceMappingURL=DataTransport.d.ts.map